brick-0.18: A declarative terminal user interface library

Safe Haskell | None
Language | Haskell2010

Brick.Widgets.Border

Contents

- Border wrapper
- Horizontal border
- Vertical border
- Drawing single border elements
- Border attribute names

Description

This module provides border widgets: vertical borders, horizontal borders, and a box border wrapper widget. All functions in this module use the rendering context's active `BorderStyle`; to change the `BorderStyle`, use `withBorderStyle`.

Synopsis

- border :: Widget n -> Widget n
- borderWithLabel :: Widget n -> Widget n -> Widget n
- hBorder :: Widget n
- hBorderWithLabel :: Widget n -> Widget n
- vBorder :: Widget n
- borderElem :: (BorderStyle -> Char) -> Widget n
- borderAttr :: AttrName
- vBorderAttr :: AttrName
- hBorderAttr :: AttrName
- hBorderLabelAttr :: AttrName
- tlCornerAttr :: AttrName
- trCornerAttr :: AttrName
- blCornerAttr :: AttrName
- brCornerAttr :: AttrName

# Border wrapper

border :: Widget n -> Widget n Source #

Put a border around the specified widget.

borderWithLabel Source #

Arguments

:: Widget n | The label widget
-> Widget n | The widget to put a border around
-> Widget n |

Put a border around the specified widget with the specified label widget placed in the middle of the top horizontal border.

# Horizontal border

hBorder :: Widget n Source #

A horizontal border. Fills all horizontal space.

hBorderWithLabel Source #

Arguments

:: Widget n | The label widget
-> Widget n |

A horizontal border with a label placed in the center of the border. Fills all horizontal space.

# Vertical border

vBorder :: Widget n Source #

A vertical border. Fills all vertical space.

# Drawing single border elements

borderElem :: (BorderStyle -> Char) -> Widget n Source #

Draw the specified border element using the active border style using `borderAttr`.

# Border attribute names

borderAttr :: AttrName Source #

The top-level border attribute name.

vBorderAttr :: AttrName Source #

The vertical border attribute name.

hBorderAttr :: AttrName Source #

The horizontal border attribute name.

hBorderLabelAttr :: AttrName Source #

The attribute used for horizontal border labels.

tlCornerAttr :: AttrName Source #

The attribute used for border box top-left corners.

trCornerAttr :: AttrName Source #

The attribute used for border box top-right corners.

blCornerAttr :: AttrName Source #

The attribute used for border box bottom-left corners.

brCornerAttr :: AttrName Source #

The attribute used for border box bottom-right corners.